libstdc++: std::shared_future< _Res & > Class Template Reference

libstdc++

std::shared_future< _Res & > Class Template Reference
Concurrency » Futures

`#include <future>`

Inheritance diagram for std::shared_future< _Res & >:
[legend]

## Public Member Functions
| shared_future (const shared_future &__sf)
| shared_future (future< _Res & > &&__uf) noexcept
| shared_future (shared_future &&__sf) noexcept
_Res & | get () const
shared_future & | operator= (const shared_future &__sf)
shared_future & | operator= (shared_future &&__sf) noexcept
bool | valid () const noexcept
void | wait () const
future_status | wait_for (const chrono::duration< _Rep, _Period > &__rel) const
future_status | wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types
typedef __future_base::_Result< _Res > & | __result_type
typedef shared_ptr< _State_base > | __state_type

## Protected Member Functions
__result_type | _M_get_result () const
void | _M_swap (__basic_future &__that) noexcept

## Detailed Description

template<typename _Res>
class std::shared_future< _Res & >

Partial specialization for shared_future<R&>.

Definition at line 978 of file future.

## Member Typedef Documentation

## ◆ __result_type

typedef __future_base::_Result<_Res>& std::__basic_future< _Res >::__result_type
| protected

Definition at line 709 of file future.

## ◆ __state_type

typedef shared_ptr<_State_base> std::__basic_future< _Res >::__state_type
| protected

Definition at line 708 of file future.

## Constructor & Destructor Documentation

## ◆ shared_future() [1/4]

template<typename _Res>

std::shared_future< _Res & >::shared_future | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 983 of file future.

## ◆ shared_future() [2/4]

template<typename _Res>

std::shared_future< _Res & >::shared_future | ( | const shared_future< _Res & > & | __sf | ) |
| inline

Copy constructor.

Definition at line 986 of file future.

## ◆ shared_future() [3/4]

template<typename _Res>

std::shared_future< _Res & >::shared_future | ( | future< _Res & > && | __uf | ) |
| inlinenoexcept

Construct from a future rvalue.

Definition at line 989 of file future.

References std::move().

## ◆ shared_future() [4/4]

template<typename _Res>

std::shared_future< _Res & >::shared_future | ( | shared_future< _Res & > && | __sf | ) |
| inlinenoexcept

Construct from a shared_future rvalue.

Definition at line 994 of file future.

References std::move().

## Member Function Documentation

## ◆ _M_get_result()

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | const
| inlineprotected

Wait for the state to be ready and rethrow any stored exception.

Definition at line 748 of file future.

Referenced by get().

## ◆ _M_swap()

void std::__basic_future< _Res >::_M_swap | ( | __basic_future & | __that | ) |
| inlineprotectednoexcept

Definition at line 757 of file future.

## ◆ get()

template<typename _Res>

_Res & std::shared_future< _Res & >::get | ( |  | ) | const
| inline

Retrieving the value.

Definition at line 1012 of file future.

References _M_get_result().

## ◆ operator=() [1/2]

template<typename _Res>

shared_future & std::shared_future< _Res & >::operator= | ( | const shared_future< _Res & > & | __sf | ) |
| inline

Definition at line 998 of file future.

## ◆ operator=() [2/2]

template<typename _Res>

shared_future & std::shared_future< _Res & >::operator= | ( | shared_future< _Res & > && | __sf | ) |
| inlinenoexcept

Definition at line 1004 of file future.

## ◆ valid()

bool std::__basic_future< _Res >::valid | ( |  | ) | const
| inlinenoexcept

Definition at line 720 of file future.

## ◆ wait()

void std::__basic_future< _Res >::wait | ( |  | ) | const
| inline

Definition at line 723 of file future.

## ◆ wait_for()

future_status std::__basic_future< _Res >::wait_for | ( | const chrono::duration< _Rep, _Period > & | __rel | ) | const
| inline

Definition at line 731 of file future.

## ◆ wait_until()

future_status std::__basic_future< _Res >::wait_until | ( | const chrono::time_point< _Clock, _Duration > & | __abs | ) | const
| inline

Definition at line 739 of file future.

The documentation for this class was generated from the following file:

- future